#include "hmg.ch" 
#include "hmg_BoxLetterShow.ch"  
#include "Encripta.prg"
#include "Newclave.prg"

/*-------------------------------------------------------*

Utilidad: Da el Cambio-Importe de la cantidad a fracionar
desglosada en grupos de Cada-Tipo-Moneda.

Los Tipos-Moneda se pueden adaptar a los de cada pais.
Bien sea sacando o poniendo Tipos-Moneda
El Sample es con Modena Euro 
*/*------------------------------------------------------*

 FUNCTION Main()

*------------------------------------------*
* (c) Mustafa Lpez  mustalopez@gmail.com
*------------------------------------------*

 SET CENTURY ON 
 SET DATE FRENCH
 SET DELETE ON 
 SET DECIMALS TO 2
 SET BROWSESYNC ON
 SET NAVIGATION EXTENDED 
 SET LANGUAGE TO SPANISH 
 SET CODEPAGE TO SPANISH   // <----------------  SET CODEPAGE TO SPANISH y sale el smbolo 

*-----------------------------------------------------------------*  
  PRIVATE aChecbo , Totax ,  nvalor , TOTA 
*-----------------------------------------------------------------*  
  PRIVATE una := 0
  una := 0
  SAVE TO zControl.mem ALL LIKE una*
*-----------------------------------------------------------------*  
  PRIVATE  BusCar
  BusCar := ALLTRIM('General Manager')
  IF ! FILE('mirax.mem')
       SAVE all like BusCar to mirax 
  ENDIF
*-----------------------------------------------------------------*  
  IF ! FILE('control.dbf')
       CrearNewFile()
  ENDIF
*-----------------------------------------------------------------*
*-----------------------------------------------------------------*
 SET TOOLTIPSTYLE BALLOON
// this follow rows is required ONLY for HMG Minigui compatibility
#ifdef __MINGW32__
   SET TOOLTIPBACKCOLOR { 193, 224, 255 } 
   SET TOOLTIPFORECOLOR { 000, 000, 000 }
#endi
*-----------------------------------------------------------------*

 DEFINE WINDOW Win_1                   ;  
       AT 100,300                      ;
       WIDTH 660 HEIGHT 580            ;  
       NOCAPTION TOPMOST NOSIZE MAIN   ;
       ON INIT password_control()             

       ON KEY ESCAPE ACTION ( SaveVentas() , Win_1.Release )

*------------------------------------------------------------------------------------*

       NewBoxShadow( 0, 0, 660, 581 ,"04qa" ,"05qa ","06qa", .T. , .F. , .T. , 255,255,255,  200,200,200 )  

        Win_1.Label_04qa.Enabled := .F.    
        Win_1.Label_05qa.Enabled := .F. 
        Win_1.Label_06qa.Enabled := .F.  

       NewBoxShadow( 010, 010, 646, 567 ,"07qa" ,"08qa ","09qa", .F. , .F. , .T. , 255,255,255,  000,091,000 )    

        Win_1.Label_07qa.Enabled := .F.    
        Win_1.Label_08qa.Enabled := .F.  
        Win_1.Label_09qa.Enabled := .F. 

*------------------------------------------------------------------------------------*

       LetterShadow ( 045, 225 ,"00x","01x","Cambio Moneda","Arial",27,.T.,.T., 000,000,000, 250,238,002 ) 

       BoxShadow( 025, 070, 084, 078 ,"01a" ,"02a", 128 ,126 , 255 )     

       DEFINE IMAGE Imag_01
            ROW    025 
            COL    070
            WIDTH  073 
            HEIGHT 066 
            PICTURE "Resource\imagen01.jpg" 
            VISIBLE .T.
       END IMAGE

*------------------------------------------------------------------------------------*
 
       BoxShadow( 122, 059, 109, 314 ,"03a" ,"04a", 128 ,126 , 255 )     

       DEFINE IMAGE Imag_02
            ROW    123 
            COL    061
            WIDTH  095 
            HEIGHT 300   
            PICTURE "Resource\imagen02.jpg"   
            VISIBLE .T.
       END IMAGE 

*-------------------------------------------------------------------------------------*

       LetterShadow ( 113, 185 ,"02xz","03xz","User","Arial",24,.T.,.T., 000,000,000, 250,238,002 ) 

       @ 106,329 LABEL  Label_User VALUE " "           ;     
                 Width  251  Height 045 CENTERALIGN    ; 
                 FONT "Arial" SIZE 24 BOLD ITALIC      ;
                 FONTCOLOR {000,000,000} BACKCOLOR {255,174,255 }  

*------------------------------------------------------------------------------------*

       LetterShadow ( 177, 185 ,"02x","03x","Venta","Arial",24,.T.,.T., 000,000,000, 250,238,002 )  

       @ 170,330 TEXTBOX Text_01 WIDTH 250 HEIGHT 45    ;   
                 FONT "ARIAL" SIZE 25 BOLD ITALIC       ;
                 BACKCOLOR  { 255,174,255 }             ;
                 VALUE 0 Numeric                        ;
                 INPUTMASK "9,999,999.99 " FORMAT 'E'  ;
                 ON CHANGE {|| SetConfOFF(0,Len("999,999.99")) }

*------------------------------------------------------------------------------------*

       LetterShadow ( 241, 185 ,"04x","05x","Efectivo","Arial",24,.T.,.T., 000,000,000, 250,238,002 ) 

       @ 234,330 TEXTBOX Text_02 WIDTH 250 HEIGHT 45    ; 
                 FONT "ARIAL" SIZE 25 BOLD ITALIC       ;
                 BACKCOLOR  { 255,174,255 }             ; 
                 VALUE 0 Numeric                        ;
                 INPUTMASK "9,999,999.99 " FORMAT 'E'  ;
                 ON CHANGE {|| SetConfOFF(0,Len("999,999.99"))  }             

*------------------------------------------------------------------------------------*

       LetterShadow ( 305, 185 ,"06x","07x","Card","Arial",24,.T.,.T., 000,000,000, 250,238,002 ) 

       @ 298,330 TEXTBOX Text_03 WIDTH 250 HEIGHT 45    ;  
                 FONT "ARIAL" SIZE 25 BOLD ITALIC       ;
                 BACKCOLOR  { 255,174,255 }             ; 
                 VALUE 0 Numeric                        ;
                 INPUTMASK "9,999,999.99 " FORMAT 'E'  ;
                 ON CHANGE {|| SetConfOFF(0,Len("999,999.99"))  }             

       Win_1.Text_03.Enabled  := .F. 
       Win_1.Text_03.Readonly := .T.

*------------------------------------------------------------------------------------*

       LetterShadow ( 369, 185 ,"08x","09x","Cambio","Arial",24,.T.,.T., 000,000,000, 250,238,002 ) 

       @ 362,330 TEXTBOX Text_04  WIDTH 250 HEIGHT 45   ;  
                 FONT "ARIAL" SIZE 25 BOLD ITALIC       ;
                 BACKCOLOR  { 255,174,255 }             ; 
                 VALUE 0 Numeric                        ;
                 INPUTMASK "9,999,999.99 " FORMAT 'E'  ;
                 ON CHANGE AsignValue()        
   
*------------------------------------------------------------------------------------*

       LetterShadow ( 435, 185 ,"10x","11x","Pago Credit Card -> [ No ] ","Arial",12,.T.,.T., 000,000,000, 250,238,002 ) 

       LetterShadow ( 435, 185 ,"13x","14x","Pago Credit Card -> [ Yes ]","Arial",12,.T.,.T., 000,000,000, 250,238,002 )  

       Win_1.Label_13x.HIDE
       Win_1.Label_14x.HIDE

     DEFINE CHECKBOX Check_1
        ROW    430  
        COL    393  
        WIDTH  020  
        HEIGHT 028
        CAPTION ""  
        VALUE .F.               
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        ONCHANGE CambiaX()                        
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .T.
        FONTITALIC .T.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        BACKCOLOR { 000,091,000 } 
        FONTCOLOR Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
     END CHECKBOX

     DEFINE IMAGE Imag_03
        ROW    425 
        COL    420 
        WIDTH  046  
        HEIGHT 032  
        PICTURE "Resource\Visa.jpg"   
        VISIBLE .T.
     END IMAGE 

*------------------------------------------------------------------------------------*

         
               @ 480,030 BUTTON But_00               ;    
                          CAPTION "Exit"             ;                   
                          TOOLTIP 'Exit'             ;
                          WIDTH 80 HEIGHT 53         ; 
                          FONT "ARIAL" SIZE 10 BOLD ITALIC ;
                          ACTION  ( SaveVentas() , Win_1.Release )


               @ 480,135 BUTTON But_01               ;    
                          CAPTION "Save"             ;                   
                          TOOLTIP 'Save'             ;
                          WIDTH 80 HEIGHT 53         ; 
                          FONT "ARIAL" SIZE 10 BOLD ITALIC ;
                          ACTION  SaveVentas() 


                @ 480,240 BUTTON But_02              ;    
                          CAPTION "Desglose"         ;                   
                          TOOLTIP 'Desglose'         ;
                          WIDTH 80 HEIGHT 53         ; 
                          FONT "ARIAL" SIZE 10 BOLD ITALIC ;
                          ACTION  Cambio_Edit()

                @ 480,345 BUTTON But_03              ;    
                          CAPTION "Cancel"           ;                   
                          TOOLTIP 'Cancel'           ;
                          WIDTH 80 HEIGHT 53         ; 
                          FONT "ARIAL" SIZE 10 BOLD ITALIC ;
                          ACTION  (  Limpiax() , CambiaX() )   


                @ 480,449 BUTTON But_04              ;    
                          CAPTION "New Key"          ;                   
                          TOOLTIP 'New Key'          ;
                          WIDTH 80 HEIGHT 53         ; 
                          FONT "ARIAL" SIZE 10 BOLD ITALIC ;
                          ACTION NEWCLAVE() 


                @ 480,550 BUTTON But_05              ;    
                          CAPTION "Report"           ;                   
                          TOOLTIP 'Report'           ;
                          WIDTH 80 HEIGHT 53         ; 
                          FONT "ARIAL" SIZE 10 BOLD ITALIC ;
                          ACTION  ( CreateReport() , ExecuteReport('Report1',.T.) )

   END WINDOW


     SETWINDOWCURSOR ( Win_1. But_00.Handle, "resource\finger.cur")


     ACTIVATE WINDOW Win_1
     CENTER WINDOW Win_1 

     Win_1.Check_1.Value  := .F.
     

RETURN(NIL)

*---------------------------------------------------------------------------------------------------------------------*
*-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-*
*---------------------------------------------------------------------------------------------------------------------*


*----------------------------------------*
 Function User_Name()
*----------------------------------------*

  RESTORE FROM user.mem ADDITIVE 

  Win_1.Label_User.Value := BUSNOM 

  RETURN(NIL)

*----------------------------------*
 Function Tablax()
*----------------------------------*

   RESTORE FROM mirax.mem  ADDITIVE

   IF BusCar = 'General Manager'

         Win_1.But_04.Enabled := .T.  

   ENDIF   

   IF BUSCAR = 'Manager R.Human'

        Win_1.But_04.Enabled := .T.  
 
   ENDIF   

   
   IF BUSCAR = 'Manager Financial'

        Win_1.But_04.Enabled := .F.  
          
   ENDIF   

   
   IF BUSCAR = 'Section Chief'

        Win_1.But_04.Enabled := .F.  

   ENDIF   

  
   IF BUSCAR = 'Administrative Officer 1'

       Win_1.But_04.Enabled := .F.
  
   ENDIF   


   IF BUSCAR = 'Administrative Officer 2'
       
       Win_1.But_04.Enabled := .F.  
 
   ENDIF   
   
   IF BUSCAR = 'Administrative Assistant'

       Win_1.But_04.Enabled := .F.  
   
   ENDIF   
 
   IF BUSCAR = 'Broker'
  
       Win_1.But_04.Enabled := .F. 
 
   ENDIF   

  
   IF BUSCAR = 'Stock Foreman'

       Win_1.But_04.Enabled := .F. 
 
   ENDIF   


   IF BUSCAR = 'Officer 1 Stock'
        
       Win_1.But_04.Enabled := .F.  

   ENDIF   

   
   IF BUSCAR = 'Officer 2 Stock'

       Win_1.But_04.Enabled := .F.
  
   ENDIF   
  
   IF BUSCAR = 'Boy Stock'

      Win_1.But_04.Enabled := .F.  
    
   ENDIF   

 Return NIl

*----------------------------------------*
 Function password_control()   
*----------------------------------------*
  
 PRIVATE aItems := {}

 PRIVATE criptOXz , AlItemX , AlItemX2 , mirax,  nLogX

	aadd ( aItems , 'General Manager' )
	aadd ( aItems , 'Manager R.Human' )
	aadd ( aItems , 'Manager Financial' )
	aadd ( aItems , 'Section Chief' )
	aadd ( aItems , 'Administrative Officer 1' )
	aadd ( aItems , 'Administrative Officer 2' )
	aadd ( aItems , 'Administrative Assistant ' )
        aadd ( aItems , 'Broker' )
	aadd ( aItems , 'Stock Foreman' )
	aadd ( aItems , 'Officer 1 Stock' )
	aadd ( aItems , 'Officer 2 Stock' ) 
        aadd ( aItems , 'Boy Stock' ) 

  Win_1.But_04.Enabled := .F.  

*---------------------------------------------------------------*
 EntradaXX()
*---------------------------------------------------------------*

  DEFINE WINDOW Form_1                     ;
        AT    460,372                      ;
        WIDTH 295 HEIGHT 212               ;
        TITLE "System Access"              ; 
        MODAL NOSYSMENU CURSOR ""                
        ON KEY ESCAPE ACTION Salir_ExitX()         
        ON KEY ALT+F4 ACTION (  MsgStop( 'Alt+F4 - Not Allowed', ' Attention !!!') , NIL )
   
 *----------------------------------------------*

     DEFINE IMAGE Image_1
        ROW    045   
        COL    017 
        WIDTH  032
        HEIGHT 032
        PICTURE "resource\Acceso1.jpg"
        HELPID Nil
        VISIBLE .T.
        STRETCH .F.
        ACTION Nil
     END IMAGE

*-----------------------------------------------*

     DEFINE LABEL Label_01
        ROW    017
        COL    060  
        WIDTH  072 
        HEIGHT 024
        VALUE "Username:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Specify User"   
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR Nil
        FONTCOLOR Nil
    END LABEL
   
    DEFINE TEXTBOX Texto_01
        ROW    015
        COL    137   
        WIDTH  120   
        HEIGHT 023
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Key User"
        ONCHANGE Nil
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        RIGHTALIGN .F.
        PASSWORD .T.                  
        BACKCOLOR { 180,200,255 }      
        FONTCOLOR Nil
        INPUTMASK Nil
        MAXLENGTH 8                 
        FORMAT Nil
        VALUE ""
        UPPERCASE .T.   
     END TEXTBOX
   
     DEFINE LABEL Label_02
        ROW    056   
        COL    060  
        WIDTH  072 
        HEIGHT 024 
        VALUE "Charge:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "indicate charge?"
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR Nil
        FONTCOLOR Nil
     END LABEL

        nLogX  = 1

   @ 055,137 COMBOBOX Combo_01         ;            
        WIDTH 120 HEIGHT 023           ;            
        ITEMS   aItems                 ;         
        VALUE nLogX                    ;
        ON CHANGE nLogX := This.Value  ;
        FONT 'Arial' SIZE 09           ; 
        TOOLTIP 'Charge'

     DEFINE LABEL Label_03
        ROW    095  
        COL    060  
        WIDTH  061
        HEIGHT 024
        VALUE "Password:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Indicate Password"
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR Nil
        FONTCOLOR Nil
     END LABEL

     DEFINE TEXTBOX Texto_03
        ROW    095 
        COL    137  
        WIDTH  120  
        HEIGHT 023
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Key Password"
        ONCHANGE Nil
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        RIGHTALIGN .F.
        PASSWORD .T.
        BACKCOLOR { 180,200,255 }      
        FONTCOLOR Nil
        INPUTMASK Nil
        MAXLENGTH 8            
        FORMAT Nil
        VALUE ""
        UPPERCASE .F.   
     END TEXTBOX

     DEFINE BUTTON Button_01
        ROW    130   
        COL    026
        WIDTH  105
        HEIGHT 028
        CAPTION "A&ccept"
        ACTION BuscaNom()           
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Acept"
        FONTBOLD .T.
        FONTITALIC .T.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE "resource\Acep.bmp"
        PICTALIGNMENT LEFT
     END BUTTON

     DEFINE BUTTON Button_02      
        ROW    130  
        COL    150
        WIDTH  105
        HEIGHT 028
        CAPTION "C&ancel"
        ACTION  Salir_ExitX()              
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Cancel"
        FONTBOLD .T.
        FONTITALIC .T.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE "resource\Cancel.bmp"
        PICTALIGNMENT LEFT
     END BUTTON
 
   END WINDOW
   
 Form_1.Texto_01.Enabled := .T.
 Form_1.Texto_03.Enabled := .T.
 Form_1.Texto_01.SetFocus

       CENTER WINDOW Form_1  
       Form_1.Activate   

 RETURN NIL
 
*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

*------------------------*
  FUNCTION EntradaXX()
*------------------------*

 PRIVATE   c_NomC , c_ValC  , ficher 

  CLOSE DATABASES
 
   ficher:=  'control'
   
   SELECT 1
   USE &(ficher)  

   a_NomC := FIELD(1) 
   a_ValC := &a_NomC 

   b_NomC := FIELD(2) 
   b_ValC := &b_NomC 

   c_NomC := FIELD(3) 
   c_ValC := &c_NomC 
  
  DO WHILE &(ficher)->( !Eof() ) 
     REPLACE  &a_NomC WITH DeCript  ( &a_NomC , 'admin' )              
     REPLACE  &b_NomC WITH DeCript  ( &b_NomC , 'admin' ) 
     REPLACE  &c_NomC WITH DeCript  ( &c_NomC , 'admin' ) 
     &(ficher)->( DbSkip() )
  ENDDO

 CLOSE DATABASES

RETURN NIL  

*----------------------------------*
 Function BuscaNom()
*----------------------------------*

 PRIVATE BusNom , BusCla, BusCar  
                                           
 IF nLogX = 1
   
     mirax := 'General Manager'
   
 ENDIF   

 IF nLogX = 2
   
     mirax := 'Manager R.Human'
   
 ENDIF   

 IF nLogX = 3
   
     mirax := 'Manager Financial'
   
 ENDIF 
  
 IF nLogX = 4
   
     mirax := 'Section Chief'
   
 ENDIF   

 IF nLogX = 5
   
     mirax := 'Administrative Officer 1'
   
 ENDIF   

 IF nLogX = 6
   
     mirax := 'Administrative Officer 2'
   
 ENDIF   

 IF nLogX = 7
   
     mirax := 'Administrative Assistant'
   
 ENDIF   

 IF nLogX = 8
   
     mirax := 'Broker'
   
 ENDIF   

 IF nLogX = 9
   
     mirax := 'Stock Foreman'
   
 ENDIF   

 IF nLogX = 10
   
     mirax := 'Officer 1 Stock'
   
 ENDIF   

 IF nLogX = 11
   
     mirax := 'Officer 2 Stock'
   
 ENDIF   

 IF nLogX = 12
   
     mirax := 'Boy Stock'
   
 ENDIF   

*-----------------------------------------------------------------------*
*-----------------------------------------------------------------------*

   BusNom := ALLTRIM(LOWER(Form_1.Texto_01.value))  

   BusCar := ALLTRIM(mirax)

   BusCla := ALLTRIM(LOWER(Form_1.Texto_03.value)) 

   CLOSE DATABASES
 
   SELECT 1
   USE Control
     
   GOTO TOP
   LOCA FOR ALLTRIM(NAME) == BusNom .AND. ALLTRIM(CHARGE) ==  BusCar .AND. ALLTRIM(PASSWORD) ==  BusCla
  
   IF FOUND() 

      MsgInfo ("Username, Charge, Password OK !")  
      
        Form_1.Texto_01.value := ""
        Form_1.Texto_03.value := ""
    
        save all like BusCar to mirax 
        save all like BusNom to user 

        Salir_ExitXa()

   ELSE
  
                   RESTORE FROM ZControl.mem ADDITIVE 
    
                   MsgStop('Password Incorrect'+CRLF ;
                   +'Intento n:'+ SPACE(1) + ALLTRIM(STR(una+1)) ,'Password !!!') 
                   Form_1.Texto_01.value := ""
                   Form_1.Texto_03.value := "" 
              
                   ContadorS() 
   ENDIF
  
   CLOSE ALL
 

RETURN NIL  


*------------------------*
 FUNCTION ContadorS() 
*------------------------*

 una = una + 1

 SAVE TO zControl.mem ALL LIKE una* 

 RESTORE FROM zControl.mem ADDITIVE

 IF una >= 3 

    MsgStop('No more attempts are allowed','Attention !!!') 
           una = 0
           SAVE TO zControl.mem ALL LIKE una*

            CLOSE DATABASES
            SELECT 1
            USE control
            COPY TO ('Control_Back\control.dbf')
            CLOSE DATABASES
            ( Salir_ExitX() , Form_1.Release ,   Win_1.Release   )             

   RETURN NIL 

 ENDIF

 RETURN NIL 

*------------------------*
  FUNCTION Salir_ExitX()
*------------------------*

 PRIVATE   c_NomC , c_ValC  , ficher  

   ficher:=  'control'
   
   SELECT 1
   USE &(ficher)  

   a_NomC := FIELD(1) 
   a_ValC := &a_NomC 

   b_NomC := FIELD(2) 
   b_ValC := &b_NomC 

   c_NomC := FIELD(3) 
   c_ValC := &c_NomC 
  
  DO WHILE &(ficher)->( !Eof() ) 
     REPLACE  &a_NomC WITH Cript  ( &a_NomC , 'admin' )              
     REPLACE  &b_NomC WITH Cript  ( &b_NomC , 'admin' ) 
     REPLACE  &c_NomC WITH Cript  ( &c_NomC , 'admin' ) 
     &(ficher)->( DbSkip() )
  ENDDO

 CLOSE DATABASES
       SELECT 1
       USE control
       COPY TO ('Control_Back\control.dbf')
       CLOSE DATABASES
     
      ( Form_1.Release ,   Win_1.Release   ) 

 RETURN NIL  

*------------------------*
  FUNCTION Salir_ExitXa()
*------------------------*

 PRIVATE   c_NomC , c_ValC  , ficher  

 ficher:=  'control'

   SELECT 1
   USE &(ficher)  

   a_NomC := FIELD(1) 
   a_ValC := &a_NomC 

   b_NomC := FIELD(2) 
   b_ValC := &b_NomC 

   c_NomC := FIELD(3) 
   c_ValC := &c_NomC 
  
  DO WHILE &(ficher)->( !Eof() ) 
     REPLACE  &a_NomC WITH Cript  ( &a_NomC , 'admin' )              
     REPLACE  &b_NomC WITH Cript  ( &b_NomC , 'admin' ) 
     REPLACE  &c_NomC WITH Cript  ( &c_NomC , 'admin' ) 
     &(ficher)->( DbSkip() )
  ENDDO

 CLOSE DATABASES

 ( Tablax()  , User_Name() , Limpiax() , CambiaX() ) 
 
 Form_1.Release     

RETURN NIL  

*-----------------------------------------------------------------------------------------------------------------------*
*-----------------------------------------------------------------------------------------------------------------------*

*---------------------------------------------*
 FUNCTION SaveVentas()
*---------------------------------------------*

 Win_1.Text_02.Enabled := .T. 
 Win_1.Text_04.Enabled := .T. 

 RESTORE FROM user.mem ADDITIVE 
 
 USE ven_tas
 DELETE FOR VENTA   = 0
 DELETE FOR CAMBIO  < 0
 DELETE FOR TOTAL   = 0
 PACK

 APPEND BLANK 
 REPLACE USER      WITH ALLTRIM(BusNom)
 REPLACE VENTA     WITH Win_1.Text_01.VALUE 
 REPLACE EFECTIVO  WITH Win_1.Text_02.VALUE 
 REPLACE CARD      WITH Win_1.Text_03.VALUE 
 REPLACE CAMBIO    WITH Win_1.Text_04.VALUE 
 REPLACE HORA      WITH TIME()

 IF aChecbo = "False" 

        REPLACE TOTAL  WITH ( Win_1.Text_02.VALUE) - (Win_1.Text_04.VALUE )    
        REPLACE FECHA  WITH DATE()
   
        SELECT 1
        USE ven_tas 

        nvalor :=  (  Win_1.Text_02.VALUE) - (Win_1.Text_04.VALUE ) 
       
        TOTA := nValor + SUM_TOTAL 
    
        SELECT 1
        USE ven_tas 
        dbGoTop()
        REPLACE SUM_TOTAL WITH TOTA
 
   ELSE 

       REPLACE TOTAL  WITH Win_1.Text_01.VALUE  
       REPLACE FECHA  WITH DATE()

       SELECT 1 
       USE ven_tas 

       nvalor :=  Win_1.Text_01.VALUE  
       
       TOTA := nValor + SUM_TOTAL  

       SELECT 1
       USE ven_tas 
       dbGoTop()
       REPLACE SUM_TOTAL WITH TOTA
 
 ENDIF

   Win_1.Check_1.Value := .F.

   ( Limpiax() , CambiaX() )

 RETURN NIL

*---------------------------------------------*
  FUNCTION CambiaX()
*---------------------------------------------*

   aChecbo  := ( IIF(Win_1.Check_1.Value,"True","False") )
 
   IF aChecbo = "False" 

       Win_1.Label_10x.Show
       Win_1.Label_11x.Show

       Win_1.Label_13x.Hide
       Win_1.Label_14x.Hide
    
       Win_1.Text_02.Enabled  := .T. 
       Win_1.Text_02.VALUE    :=  0 

       Win_1.Text_03.Enabled  := .F. 
       Win_1.Text_03.Readonly := .T.
       Win_1.Text_03.VALUE    :=  0

       Win_1.Text_04.Enabled  := .T.
       Win_1.Text_04.VALUE    :=  0 
      
     ELSE

       Win_1.Label_10x.Hide
       Win_1.Label_11x.Hide

       Win_1.Label_13x.Show
       Win_1.Label_14x.Show

       Win_1.Text_02.Enabled  := .F. 
       Win_1.Text_02.VALUE    :=  0
     
       Win_1.Text_03.Enabled  := .T.  
       Win_1.Text_03.Readonly := .F.
       Win_1.Text_03.VALUE    :=  Win_1.Text_01.VALUE 
      
       Win_1.Text_04.Enabled  := .F. 
       Win_1.Text_04.VALUE    :=  0
    
   ENDIF

RETURN NIL

*---------------------------------------------*
 FUNCTION SetConfOFF( nMaxLength, nInputMask )
*---------------------------------------------*

 Local cFrmName   := ThisWindow.Name
 Local cCmpName   := This.FocusedControl

 If nInputMask > 0
    nMaxLength := nInputMask
 Endif

 If !Empty(cCmpName)
    If nMaxLength == GetProperty(cFrmName,cCmpName,"CaretPos")
       InsertTab()
    Endif
 Endif
Return Nil

*---------------------------------------------*
 FUNCTION AsignValue() 
*---------------------------------------------*

 LOCAL Mtotales

 IF aChecbo = "False" 

    Mtotales := Win_1.Text_02.value - Win_1.Text_01.value

    Win_1.Text_04.value := Mtotales 

 ELSE

    Win_1.Text_04.value :=  0

 ENDIF

Return Nil

*---------------------------------------------*
 FUNCTION Limpiax() 
*---------------------------------------------*

 Win_1.Text_01.value := 0
 Win_1.Text_02.value := 0
 Win_1.Text_03.value := 0
 Win_1.Text_04.value := 0

Return Nil

*---------------------------------------------*
FUNCTION Cambio_Edit()
*---------------------------------------------*

* -------------------------------
* (c) LuchoMiranda@Telefonica.Net
* -------------------------------
 LOCAL nImporte :=NIL
 LOCAL cImporte :=NIL
 LOCAL   aDatos :=NIL
 LOCAL   cDatos :=NIL

 WHILE .T.
 
   cImporte :=  STR( Win_1.Text_04.value  ) 
  
   IF EMPTY(cImporte) ==.T.
      EXIT
   ENDIF
   
   nImporte := VAL(cImporte)

   aDatos   := Cambio_Importe(nImporte)
   
   cDatos :="Cambio: "  + LTRIM(cImporte) + " " + CHR(13) + CHR(13)   
   cDatos +="Desglose-Cambio:"            + CHR(13)
   
   AEVAL(aDatos,{|x| cDatos +=STR(x[1]) + STR(x[2]) + CHR(13)})
   
   MSGINFO(cDatos , 'Cambio Moneda ' )

  (   SaveVentas() , Limpiax() , CambiaX() )

   RETURN(NIL)    
   
 ENDDO

RETURN(NIL)

*---------------------------------------------*
 FUNCTION Cambio_Importe(nImporte) 
*---------------------------------------------*

* -------------------------------
* (c) LuchoMiranda@Telefonica.Net
* -------------------------------
 LOCAL aTipos :={ 500,200,100,50,20,10,5,1,.50,.20,.10,.05,.02,.01}  // <---- Tipo Moneda 
 LOCAL nTipos :=NIL
 LOCAL aDatos :={}
 LOCAL nTipo  :=NIL

 nImporte +=0.0050

 FOR nTipo :=1 TO LEN(aTipos)
   
    IF ( nTipos :=INT(nImporte / aTipos[nTipo]) ) <> 00
      
       AADD(aDatos, { nTipos , aTipos[nTipo] } )
      
       nImporte -=nTipos * aTipos[nTipo]
      
    ENDIF
   
 NEXT

 RETURN( aDatos )

*------------------------*
  FUNCTION CrearNewFile()
*------------------------*

 LOCAL aStruct := { ;
  { "NAME"     , "C", 30, 0 }, ;
  { "CHARGE"   , "C", 30, 0 }, ;
  { "PASSWORD" , "C", 10, 0 } ;
  }

  DbCreate( "control", aStruct, .T. )

  CLOSE DATABASES
  use control
  append blank
  repla NAME       with ALLTRIM(LOWER("admin")) 
  repla CHARGE     with ALLTRIM('General Manager')
  repla PASSWORD   with ALLTRIM(LOWER("admin")) 

 CLOSE DATABASES

 PRIVATE   c_NomC , c_ValC  , ficher  

   ficher:=  'control'
   
   SELECT 1
   USE &(ficher)  

   a_NomC := FIELD(1) 
   a_ValC := &a_NomC 

   b_NomC := FIELD(2) 
   b_ValC := &b_NomC 

   c_NomC := FIELD(3) 
   c_ValC := &c_NomC 
  
  DO WHILE &(ficher)->( !Eof() ) 
     REPLACE  &a_NomC WITH Cript  ( &a_NomC , 'admin' )              
     REPLACE  &b_NomC WITH Cript  ( &b_NomC , 'admin' ) 
     REPLACE  &c_NomC WITH Cript  ( &c_NomC , 'admin' ) 
     &(ficher)->( DbSkip() )
  ENDDO

CLOSE DATABASES

RETURN NIL  

*--------------------------------*
 FUNCTION CreateReport()
*--------------------------------*

  CLOSE DATABASES

  USE ven_tas

  DELETE FOR VENTA  = 0
  DELETE FOR CAMBIO < 0
  DELETE FOR TOTAL  = 0
  PACK

  Totax := SUM_TOTAL

*-------------------------------------------------------------------------------------------------------*

	DEFINE REPORT Report1

		* Report Layout ***********************************************

		BEGIN LAYOUT 
			PAPERSIZE	PRINTER_PAPER_A4
			ORIENTATION	PRINTER_ORIENT_PORTRAIT 
		END LAYOUT

		* Header Band *************************************************

		BEGIN HEADER

			BANDHEIGHT	25
			
			BEGIN TEXT
				EXPRESSION      'Venta  Mercancias'
				ROW		010  	
				COL		075   
				WIDTH		100	
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	20	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left
			END TEXT

			BEGIN PICTURE
				VALUE	        'Resource\descarga.jpg'  
				ROW		008   	  
				COL		023  
				WIDTH		011	
				HEIGHT		011	
				STRETCH		.F.
			END PICTURE


                        BEGIN LINE
				FROMROW		023
				FROMCOL		010
				TOROW		023
				TOCOL		200
				PENWIDTH	0.1
				PENCOLOR	{ 0 , 0 , 0 }
			END LINE

                        BEGIN TEXT                                                            
			        EXPRESSION      'USER               VENTA         EFECTIVO              CARD'
				ROW		024 	
				COL		014   
				WIDTH		100	
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	 11	
				FONTBOLD	.T.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left
			END TEXT

                        BEGIN TEXT
		                EXPRESSION      'CAMBIO          TOTAL      HORA      FECHA'
				ROW		024 	
				COL		120   
				WIDTH		100	
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	 11	
				FONTBOLD	.T.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left
			END TEXT
                      
                        BEGIN LINE
				FROMROW		030
				FROMCOL		010
				TOROW		030
				TOCOL		200
				PENWIDTH	0.1
				PENCOLOR	{ 0 , 0 , 0 }
			END LINE

		END HEADER

		* Detail Band *************************************************


                BEGIN DETAIL

			BANDHEIGHT	6


                      BEGIN TEXT
				EXPRESSION	ALLTRIM(ven_tas->USER)  
				ROW		011
				COL		013 
				WIDTH		025  
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
                                FORMAT          'E'
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left   
			END TEXT

                        BEGIN TEXT
				EXPRESSION	STR(ven_tas->VENTA)  
				ROW		011
				COL		029 
				WIDTH		025  
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
                                FORMAT          'E'
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	RIGHT  
			END TEXT

			BEGIN TEXT
				EXPRESSION	STR(ven_tas->EFECTIVO)  
				ROW		011
				COL		058
				WIDTH		025    
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	RIGHT 
			END TEXT

			BEGIN TEXT
				EXPRESSION	STR(ven_tas->CARD)  
				ROW		011
				COL		084 
				WIDTH		025     
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	RIGHT 
			END TEXT

			BEGIN TEXT
				EXPRESSION	STR(ven_tas->CAMBIO)  
				ROW		011
				COL		110
				WIDTH		025 
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	RIGHT 
			END TEXT

			BEGIN TEXT
				EXPRESSION	STR(ven_tas->TOTAL)  
				ROW		011
				COL		134  
				WIDTH		025 
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	RIGHT 
			END TEXT

                        BEGIN TEXT
				EXPRESSION	ALLTRIM(ven_tas->HORA)  
				ROW		011
				COL		164
				WIDTH		012  
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	RIGHT 
			END TEXT


                        BEGIN TEXT
				EXPRESSION	DTOC(ven_tas->FECHA)        
				ROW		011
				COL		183  
				WIDTH		055 
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

		END DETAIL

		* Footer Band *************************************************

		BEGIN FOOTER

			BANDHEIGHT	27

			BEGIN LINE
				FROMROW		010  
				FROMCOL		010	
				TOROW		010  
				TOCOL		200	
				PENWIDTH	0.1	
				PENCOLOR	{ 0 , 0 , 0 }	
			END LINE

			BEGIN TEXT
				EXPRESSION	'Page. No:' + Str(_PageNo)
				ROW		012  	
				COL		011	
				WIDTH		100	
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	12	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

			BEGIN TEXT
				EXPRESSION	Date()
				ROW		012  
				COL		177	
				WIDTH		030	
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	12	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

		END FOOTER

		* Summary Band ************************************************

		BEGIN SUMMARY

			BANDHEIGHT	50

			BEGIN TEXT
				EXPRESSION	'Total Records: ' +SPACE(5)+ ALLTRIM(Str(RecCount()))
				ROW		020  
				COL		020	
				WIDTH		100	
				HEIGHT		030
				FONTNAME	'Helvetica'
				FONTSIZE	12	
				FONTBOLD	.T.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

			BEGIN TEXT
				EXPRESSION	'Total Ventas:' 
				ROW		020  
				COL		100 
				WIDTH		100	
				HEIGHT		030
				FONTNAME	'Helvetica'
				FONTSIZE	12	
				FONTBOLD	.T.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

                        BEGIN TEXT
                                EXPRESSION	STR(Totax) +'  '     
                                ROW		020  
				COL		065   
				WIDTH		100	
				HEIGHT		030
				FONTNAME	'Helvetica'
				FONTSIZE	12	
				FONTBOLD	.T.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	RIGHT
			END TEXT


		END SUMMARY

	END REPORT

Return

*-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-*























